-- author: 	Sol 
-- website: www.polish-frags.pl
-- MySql stats logger
--[[	Struct
		guid 	txt
		ip		txt
		name	txt
		cname	txt
		
		kills	int
		deaths	int
		xp		int
]]--
Table = "Clients"

require "luasql.mysql"
env = assert (luasql.mysql())
con = assert(env:connect("dbname", "dbuser", "dbpassword", "dbhost", "dbport"))	-- default port: 3306

debug = 0

gstate = true

function et_InitGame( levelTime, randomSeed, restart )
	et.RegisterModname( "Sol's dbstats logger 1.0" )
	gstate = true
end

function et_RunFrame( levelTime )
	if tonumber(et.trap_Cvar_Get("gamestate")) == 3 and gstate == true then
		sv_maxclients = tonumber(et.trap_Cvar_Get("sv_maxclients"))
	
			for i = 0, (tonumber(et.trap_Cvar_Get( "sv_maxclients" )) - 1) do
				if et.gentity_get(i, "sess.sessionTeam") ~= 0 then
					check = GetPlayerDB(et.Info_ValueForKey(et.trap_GetUserinfo( i ), "sil_guid"))
					if debug == 1 then
						if check ~= nil then
							et.G_Print("Found: "..check["name"].."\n")
						else et.G_Print("User Doesn't exist\n") end
					else
						if check ~= nil then
							UpdatePlayerDB( i )
						else
							if string.len(et.Info_ValueForKey(et.trap_GetUserinfo( i ), "sil_guid")) == 32 then
								SetPlayerDB( i )
							else break end
						end
					end
				end
			end	
		gstate = false
	end
end

function et_ClientCommand(clientnum, command)
	if command ~= "say" then 
		return 
	end
	
	if et.trap_Argv(1) == "!ratio" then
		local info = GetPlayerDB(et.Info_ValueForKey(et.trap_GetUserinfo(clientnum), "sil_guid"))
		et.trap_SendConsoleCommand(et.EXEC_APPEND, string.format("chat %s's ^3ratio: %3g (K/D)(%d/%d)\n",et.gentity_get(clientnum, "pers.netname"), Ratio(info["kills"],info["deaths"]), info["kills"], info["deaths"]))
	end
end

--    "INSERT INTO Clients (guid, ip, name, cname, kills, deaths, xp) VALUES ('','','')"

function SetPlayerDB(num)
	local userinfo = et.trap_GetUserinfo(num)
	name = et.Q_CleanStr( et.gentity_get(num,"pers.netname") ) 
	local dbmsg = "INSERT INTO "..Table.." (guid, ip, name, cname, kills, deaths, xp) VALUES ('"
		..et.Info_ValueForKey(userinfo, "sil_guid").."', '"
		..ComIP(num).."', '"
		..name.."', '"
		..et.gentity_get(num,"pers.netname").."', '"
	-- FIXME Get Kills and deaths from database and    ( K/D += Current )
		..et.gentity_get(num,"sess.kills").."', '"
		..et.gentity_get(num,"sess.deaths").."', '"
		..et.gentity_get(num,"sess.game_points").."')"
	--..et.Info_ValueForKey(userinfo, "ip").."', '"
	cur = assert (con:execute(dbmsg))
	--ClrStats(num)
end

function GetPlayerDB(guid)
	cur = assert (con:execute("SELECT * FROM "..Table.." WHERE guid='".. guid .."'"))
	row = cur:fetch ({}, "a")
	cur:close()
	return row
end

function UpdatePlayerDB(num)
	local userinfo 	= et.trap_GetUserinfo(num)
	local cl		= GetPlayerDB(et.Info_ValueForKey(userinfo, "sil_guid")) -- key
	local dbmsg 	= "UPDATE "..Table.." SET ip='"..ComIP(num).."', \
		name='"..et.Q_CleanStr( et.gentity_get(num,"pers.netname") ).."', \
		cname='"..et.gentity_get(num,"pers.netname").."', \
		kills='"..(tonumber(cl["kills"])+et.gentity_get(num,"sess.kills")).."', \
		deaths='"..(tonumber(cl["deaths"])+et.gentity_get(num,"sess.deaths")).."', \
		xp='"..et.gentity_get(num,"sess.game_points").."' WHERE guid='"..et.Info_ValueForKey(userinfo, "sil_guid").."'"
		cur = assert (con:execute(dbmsg))
	--ClrStats(num)
end

--[[function ClrStats(num)
	et.gentity_set(num, "sess.kills" 0)
	et.gentity_set(num, "sess.deaths" 0)
end]]--

function ComIP(num)
	local ips = et.Info_ValueForKey(et.trap_GetUserinfo(num), "ip")
	if ips ~= "localhost" then
		s,e,ip = string.find(ips,"(%d+%.%d+%.%d+%.%d+)")
		return ip
	else
		return "localhost"
	end
end

function Ratio(k,d)
	return (string.sub(string.format("%f",(k/d)),0,5))
end